SystemOrganization addCategory: #'WidgetTools-IconPicker'!
SystemOrganization addCategory: #'WidgetTools-ResourceMonitor'!
SystemOrganization addCategory: #'WidgetTools-WorldToolbar'!
SystemOrganization addCategory: #'WidgetTools-MessageListDialog'!
SystemOrganization addCategory: #'WidgetTools-SystemProgress'!
SystemOrganization addCategory: #'WidgetTools-SystemSearch'!

UiPropertyItemNode subclass: #UiBenchmarkNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WidgetTools-ResourceMonitor'!

!UiBenchmarkNode methodsFor: 'accessing' stamp: 'mt 1/25/2012 13:42:45.872'!
bench

	^ self at: #bench ifAbsent: []! !

!UiBenchmarkNode methodsFor: 'accessing' stamp: 'mt 1/25/2012 13:43:05.181'!
bench: anInteger

	self at: #bench put: anInteger.
	self propertyChanged: #bench.! !

!UiBenchmarkNode methodsFor: 'menu' stamp: 'mt 1/25/2012 14:03:31.96'!
benchMenu

	| menu |
	menu := MenuMorph new
		defaultTarget: self.
		
	menu add: 'Bench' action: #updateBench.
	
	^ menu! !

!UiBenchmarkNode methodsFor: 'accessing' stamp: 'mt 1/25/2012 13:40:04.295'!
code

	^ self at: #code ifAbsent: []! !

!UiBenchmarkNode methodsFor: 'accessing' stamp: 'mt 1/26/2012 10:57:31.777'!
code: aString

	self at: #code put: aString.
	
	"Cached results are no longer valid."
	self
		ttr: nil;
		ttrNoGC: nil;
		bench: nil.! !

!UiBenchmarkNode methodsFor: 'accessing' stamp: 'mt 1/25/2012 14:06:33.247'!
label

	^ self at: #label! !

!UiBenchmarkNode methodsFor: 'tracing' stamp: 'mt 2/16/2012 11:59:48.088'!
trace

	self shouldBeImplemented..
	"Cursor wait showWhile: [
		SdIDE traceSourceCode: self code, ' value']."! !

!UiBenchmarkNode methodsFor: 'menu' stamp: 'mt 1/25/2012 14:04:13.207'!
traceMenu

	| menu |
	menu := MenuMorph new
		defaultTarget: self.
		
	menu add: 'Trace' action: #trace.
	
	^ menu! !

!UiBenchmarkNode methodsFor: 'accessing' stamp: 'mt 1/25/2012 13:42:25.206'!
ttr

	^ self at: #ttr ifAbsent: []! !

!UiBenchmarkNode methodsFor: 'accessing' stamp: 'mt 1/25/2012 13:43:37.692'!
ttr: aNumber

	self at: #ttr put: aNumber.
	self propertyChanged: #ttr.! !

!UiBenchmarkNode methodsFor: 'accessing' stamp: 'mt 1/25/2012 13:42:31.497'!
ttrNoGC

	^ self at: #ttrNoGC ifAbsent: []! !

!UiBenchmarkNode methodsFor: 'accessing' stamp: 'mt 1/25/2012 13:43:50.277'!
ttrNoGC: aNumber

	self at: #ttrNoGC put: aNumber.
	self propertyChanged: #ttrNoGC.! !

!UiBenchmarkNode methodsFor: 'benchmarks' stamp: 'mt 1/25/2012 13:46:53.025'!
updateBench

	Cursor wait showWhile: [  
		self bench: (Compiler evaluate: self code) bench].
		! !

!UiBenchmarkNode methodsFor: 'benchmarks' stamp: 'mt 1/25/2012 13:45:26.447'!
updateTtr

	| block results |
	block := Compiler evaluate: self code.
	results :=  OrderedCollection new.
	5 timesRepeat: [results add: block timeToRun asInteger].

	self ttr: results average truncated.! !

!UiBenchmarkNode methodsFor: 'benchmarks' stamp: 'mt 1/25/2012 13:44:58.779'!
updateTtrNoGC

	| block results |
	block := Compiler evaluate: self code.
	results :=  OrderedCollection new.
	5 timesRepeat: [results add: block timeToRunWithoutGC asInteger].

	self ttrNoGC: results average truncated.! !

UiPropertyItemNode subclass: #UiResourceMonitorNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WidgetTools-ResourceMonitor'!

!UiResourceMonitorNode methodsFor: 'accessing' stamp: 'mt 1/25/2012 13:59:27.372'!
description

	^ self at: #description! !

!UiResourceMonitorNode methodsFor: 'accessing' stamp: 'mt 1/25/2012 14:00:12.987'!
iconicState

	^ (self threshold notNil and: [self value > self threshold])
		ifTrue: [UiDiagonaIcons icon0150Normal]
		ifFalse: [UiSilkIcons acceptIcon]! !

!UiResourceMonitorNode methodsFor: 'accessing' stamp: 'mt 1/25/2012 13:59:01.84'!
label

	^ self at: #label! !

!UiResourceMonitorNode methodsFor: 'accessing' stamp: 'mt 1/25/2012 13:59:17.188'!
threshold

	^ self at: #threshold! !

!UiResourceMonitorNode methodsFor: 'accessing' stamp: 'mt 1/25/2012 13:59:09.717'!
value

	^ self at: #value! !

UiWindow subclass: #UiMessageListDialog
	instanceVariableNames: 'result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WidgetTools-MessageListDialog'!

!UiMessageListDialog commentStamp: 'mt 10/30/2010 18:36:14.08' prior: 0!
I can show a list of short messages to be confirmed or rejected.!

!UiMessageListDialog methodsFor: 'as yet unclassified' stamp: 'mt 10/30/2010 19:29:44.076'!
addIcon: aForm text: aText

	self ui messageList addIcon: aForm text: aText.! !

!UiMessageListDialog methodsFor: 'as yet unclassified' stamp: 'mt 10/30/2010 19:29:55.52'!
addText: aText

	self ui messageList addText: aText.! !

!UiMessageListDialog methodsFor: 'initialization' stamp: 'mt 3/29/2011 10:46:42.014'!
initialize

	super initialize.
	
	self ui messageList
		verticalScrollBarPolicy: #alwaysOff;
		horizontalScrollBarPolicy: #alwaysOff;    
		selectionBehavior: UiViewNullSelection;
		color: Color transparent.
		
	self connect: self ui okButton signal: #clicked: toSelector: #result: pattern: #(=true).
	self connect: self ui cancelButton signal: #clicked: toSelector: #result: pattern: #(=false).! !

!UiMessageListDialog methodsFor: 'accessing' stamp: 'mt 10/30/2010 19:29:10.718'!
result

	^ result! !

!UiMessageListDialog methodsFor: 'accessing' stamp: 'mt 10/30/2010 19:27:11.513'!
result: aBoolean

	result := aBoolean.! !

!UiMessageListDialog methodsFor: 'as yet unclassified' stamp: 'mt 10/30/2010 20:06:45.019'!
show: aTitleString
	
	^ self show: aTitleString in: ActiveWorld! !

!UiMessageListDialog methodsFor: 'as yet unclassified' stamp: 'mt 10/30/2010 20:10:23.108'!
show: aTitleString in: aMorph.
	
	self result: nil.
	
	(self openInWindowLabeled: aTitleString)
		center: aMorph center.
		
	[self isInWorld and: [self result isNil]] whileTrue: [ActiveWorld doOneSubCycle].

	self owner delete.

	^ self result! !

!UiMessageListDialog methodsFor: 'accessing' stamp: 'mt 11/27/2010 14:03:28.185'!
uiClass

	^ UiMessageListDialogUi! !

UiWindow subclass: #UiSystemSearch
	instanceVariableNames: 'finder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WidgetTools-SystemSearch'!

!UiSystemSearch methodsFor: 'actions' stamp: 'mt 2/8/2012 10:50:14.148'!
addResult: aModelIndex

	self ui results addItem: (UiListWidgetItem new
		at: #index put: aModelIndex;
		text: ('{1} <font color="#AAAAAA">{2}</font>' format: {aModelIndex node label. (aModelIndex node class name allButFirst: 11) allButLast: 4}) asHtmlText).! !

!UiSystemSearch methodsFor: 'accessing' stamp: 'mt 2/6/2012 17:59:33.758'!
checkBlock

	^ [:node | node label beginsWith: self ui searchEdit theText asString]! !

!UiSystemSearch methodsFor: 'actions' stamp: 'mt 2/7/2012 17:14:49.661'!
findNext

	self ui concurrentChk checked
		ifTrue: [self findNextAsynchronous]
		ifFalse: [self findNextSynchronous]! !

!UiSystemSearch methodsFor: 'actions' stamp: 'mt 2/8/2012 10:58:36.017'!
findNextAsynchronous

	self finder reset.
	self ui results clear.
	self finder
		nextSatisfying: self checkBlock
		forkAt: 35.
	self ui searchEdit readOnly: true.
	! !

!UiSystemSearch methodsFor: 'actions' stamp: 'mt 2/7/2012 17:27:09.371'!
findNextSynchronous

	self selectResult: (self finder nextSatisfying: self checkBlock).! !

!UiSystemSearch methodsFor: 'actions' stamp: 'mt 2/7/2012 17:15:12.605'!
findPrev

		self ui concurrentChk checked
		ifTrue: [self findPrevAsynchronous]
		ifFalse: [self findPrevSynchronous]! !

!UiSystemSearch methodsFor: 'actions' stamp: 'mt 2/8/2012 10:58:42.99'!
findPrevAsynchronous

	self finder reset.
	self ui results clear.
	self finder
		previousSatisfying: self checkBlock
		forkAt: 35.
	self ui searchEdit readOnly: true.! !

!UiSystemSearch methodsFor: 'actions' stamp: 'mt 2/7/2012 17:26:52.881'!
findPrevSynchronous

	self selectResult: (self finder previousSatisfying: self checkBlock).! !

!UiSystemSearch methodsFor: 'accessing' stamp: 'mt 2/6/2012 16:49:09.507'!
finder

	^ finder! !

!UiSystemSearch methodsFor: 'accessing' stamp: 'mt 2/6/2012 16:49:39.333'!
finder: aFinder

	finder := aFinder.! !

!UiSystemSearch methodsFor: 'initialization' stamp: 'mt 5/2/2012 10:31:57.59'!
initialize

	super initialize.
	
	self initializeView.
	
	self ui searchEdit deferEditSignalTime: 300.
	
	"Initialize finder."
	self finder: (UiItemModelFinder on: self ui view model).
	self finder traversalMode: #depthFirst.
	
	"Initialize buttons."
	self connect: self ui prevBtn signal: #clicked: toSelector: #findPrev.
	self connect: self ui nextBtn signal: #clicked: toSelector: #findNext.
	
	"Crosscutting connections."	
	self connect: self ui searchEdit signal: #textEdited: to: self finder selector: #reset.
	self connect: self ui searchEdit signal: #textEdited: toSelector: #updateSearchButtons.
	
	self updateSearchButtons.
	
	"Asynch search."
	self connect: self finder signal: #foundIndex: toSelector: #addResult:.
	self connect: self finder signal: #finished to: self ui searchEdit selector: #readOnly: pattern: #(= false).
	self connect: self ui results signal: #activated: toSelector: #selectCachedResult:.! !

!UiSystemSearch methodsFor: 'initialization' stamp: 'mt 2/7/2012 16:01:09.529'!
initializeView

	self ui view
		"enableAutoSort;"
		addColumn: ((UiItemViewColumnSpec newFrom: {#text -> #yourself. #icon -> #yourself})
			textConverter: [:node | ((Dictionary newFrom: {
				UiSmalltalkPackageNode -> [node package name].
				UiSmalltalkCategoryNode -> [node category].
				UiSmalltalkClassNode -> [node theClass name].
				UiSmalltalkProtocolNode -> [node protocol].
				UiSmalltalkMethodNode -> [node selector]}) at: node class) value];
			iconConverter: [:node | (node isKindOf: UiSmalltalkPackageNode) ifTrue: [UiSilkIcons packageIcon] ifFalse: []]);
		addColumn: ((UiItemViewColumnSpec newFrom: {#text -> #childCount})
			textConverter: [:integer | ('<font color="#555555">', integer asString, '</font>') asHtmlText]);
		addColumn: ((UiItemViewColumnSpec newFrom: {#text -> #yourself})
			textConverter: [:node | ('<font color="#555555">{1}</font>' format: {((Dictionary newFrom: {
				UiSmalltalkPackageNode -> ['package'].
				UiSmalltalkCategoryNode -> ['system category'].
				UiSmalltalkClassNode -> ['class'].
				UiSmalltalkProtocolNode -> ['protocol'].
				UiSmalltalkMethodNode -> ['method']}) at: node class) value}) asHtmlText]);
		model: UiSmalltalkModel new;
		removeHorizontalHeader.! !

!UiSystemSearch methodsFor: 'updating' stamp: 'mt 2/7/2012 17:21:28.795'!
log: msg

	self ui statusLbl text: msg.! !

!UiSystemSearch methodsFor: 'actions' stamp: 'mt 2/8/2012 10:52:01.257'!
selectCachedResult: anItem

	"faster than lookup index in view via #modelIndicesFor:."	
	self ui view expandIndex: (anItem at: #index).
	
	self ui view currentNode: (anItem at: #index) node.! !

!UiSystemSearch methodsFor: 'actions' stamp: 'mt 2/7/2012 17:26:39.203'!
selectResult: aNode

	aNode
		ifNil: [
			self updateSearchButtons.
			self log: 'Search finished. No further results found.']
		ifNotNil: [:node |
			self ui view expandIndex: self finder currentIndex. "faster than lookup index in view via #modelIndicesFor:."	
			self ui view currentNode: node.
			self log: ('Found: ''{1}''' format: {node label})]! !

!UiSystemSearch methodsFor: 'actions' stamp: 'mt 2/7/2012 16:39:30.204'!
setRoot: aNode


	self finder rootIndex: (self ui view modelIndicesFor: aNode) first.
		
	self updateSearchButtons.! !

!UiSystemSearch methodsFor: 'accessing' stamp: 'mt 2/6/2012 16:43:02.915'!
title

	^ 'Squeak System Search'! !

!UiSystemSearch methodsFor: 'accessing' stamp: 'mt 2/6/2012 16:42:37.374'!
uiClass

	^ UiSystemSearchUi! !

!UiSystemSearch methodsFor: 'updating' stamp: 'mt 2/7/2012 16:23:49.269'!
updateSearchButtons

	self ui nextBtn enabled: (self ui searchEdit theText notEmpty and: [self finder hasNext]).
	self ui prevBtn enabled: (self ui searchEdit theText notEmpty and: [self finder hasPrevious]).! !

UserInterface subclass: #UiMessageListDialogUi
	instanceVariableNames: 'messageList unnamedMorph1 unnamedMorph2 okButton cancelButton unnamedMorph3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WidgetTools-MessageListDialog'!

!UiMessageListDialogUi methodsFor: 'accessing' stamp: 'mt 10/30/2010 18:40:00.302'!
cancelButton
	"nil"
	
	^ cancelButton! !

!UiMessageListDialogUi methodsFor: 'ui - private' stamp: 'mt 10/30/2010 18:40:00.356'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (250@150).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel cellInset: (4).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (4).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	panel color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	messageList := UiListWidget new.
	messageList extent: (242@115).
	messageList position: (4@4).
	messageList hResizing: (#spaceFill).
	messageList vResizing: (#spaceFill).
	messageList cellInset: (0).
	messageList cellPositioning: (#center).
	messageList cellSpacing: (#none).
	messageList layoutInset: (0).
	messageList listCentering: (#topLeft).
	messageList listDirection: (#topToBottom).
	messageList listSpacing: (#none).
	messageList maxCellSize: (1073741823).
	messageList minCellSize: (0).
	messageList wrapCentering: (#topLeft).
	messageList wrapDirection: (#none).
	messageList frameFractions: (0@0 corner: 1@1).
	messageList frameOffsets: (0@0 corner: 0@0).
	messageList balloonText: (nil).
	messageList balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	messageList modelClass: (UiListWidgetModel).
	messageList horizontalHeaderVisible: (false).
	messageList verticalHeaderVisible: (false).
	messageList setProperty: #objectName toValue: 'messageList'.
	panel addMorphBack: messageList.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (242@22).
	unnamedMorph1 position: (4@123).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#shrinkWrap).
	unnamedMorph1 cellInset: (4).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (0).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#leftToRight).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	unnamedMorph1 color: (Color transparent).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	unnamedMorph2 := UiSpacer new.
	unnamedMorph2 extent: (61@20).
	unnamedMorph2 position: (4@124).
	unnamedMorph2 hResizing: (#spaceFill).
	unnamedMorph2 vResizing: (#rigid).
	unnamedMorph2 cellInset: (4).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (4).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#topToBottom).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 balloonText: (nil).
	unnamedMorph2 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	unnamedMorph2 color: (Color blue).
	unnamedMorph2 borderWidth: (0).
	unnamedMorph2 borderStyle2: (#simple).
	unnamedMorph2 borderColor: (Color black).
	unnamedMorph2 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph2.
	okButton := UiPushButton new.
	okButton changeTableLayout.
	okButton extent: (42@21).
	okButton position: (69@123).
	okButton hResizing: (#shrinkWrap).
	okButton vResizing: (#shrinkWrap).
	okButton cellInset: (4).
	okButton cellPositioning: (#center).
	okButton cellSpacing: (#none).
	okButton layoutInset: (2@0 corner: 2@0).
	okButton listCentering: (#topLeft).
	okButton listDirection: (#leftToRight).
	okButton listSpacing: (#none).
	okButton maxCellSize: (1073741823).
	okButton minCellSize: (0).
	okButton wrapCentering: (#topLeft).
	okButton wrapDirection: (#none).
	okButton frameFractions: (0@0 corner: 1@1).
	okButton frameOffsets: (0@0 corner: 0@0).
	okButton balloonText: (nil).
	okButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	okButton setProperty: #iconByDesigner toValue: 'UiSilkIcons acceptIcon'.
	okButton icon: (UiSilkIcons acceptIcon).
	okButton text: ('OK').
	okButton color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	okButton checkable: (false).
	okButton checked: (false).
	okButton autoExclusive: (false).
	okButton setProperty: #objectName toValue: 'okButton'.
	unnamedMorph1 addMorphBack: okButton.
	cancelButton := UiPushButton new.
	cancelButton changeTableLayout.
	cancelButton extent: (62@21).
	cancelButton position: (117@123).
	cancelButton hResizing: (#shrinkWrap).
	cancelButton vResizing: (#shrinkWrap).
	cancelButton cellInset: (4).
	cancelButton cellPositioning: (#center).
	cancelButton cellSpacing: (#none).
	cancelButton layoutInset: (2@0 corner: 2@0).
	cancelButton listCentering: (#topLeft).
	cancelButton listDirection: (#leftToRight).
	cancelButton listSpacing: (#none).
	cancelButton maxCellSize: (1073741823).
	cancelButton minCellSize: (0).
	cancelButton wrapCentering: (#topLeft).
	cancelButton wrapDirection: (#none).
	cancelButton frameFractions: (0@0 corner: 1@1).
	cancelButton frameOffsets: (0@0 corner: 0@0).
	cancelButton balloonText: (nil).
	cancelButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	cancelButton setProperty: #iconByDesigner toValue: 'UiFugueIcons crossCircleIcon'.
	cancelButton icon: (UiFugueIcons crossCircleIcon).
	cancelButton text: ('Cancel').
	cancelButton color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	cancelButton checkable: (false).
	cancelButton checked: (false).
	cancelButton autoExclusive: (false).
	cancelButton setProperty: #objectName toValue: 'cancelButton'.
	unnamedMorph1 addMorphBack: cancelButton.
	unnamedMorph3 := UiSpacer new.
	unnamedMorph3 extent: (61@20).
	unnamedMorph3 position: (185@124).
	unnamedMorph3 hResizing: (#spaceFill).
	unnamedMorph3 vResizing: (#rigid).
	unnamedMorph3 cellInset: (4).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (4).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#topToBottom).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 frameFractions: (0@0 corner: 1@1).
	unnamedMorph3 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph3 balloonText: (nil).
	unnamedMorph3 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	unnamedMorph3 color: (Color blue).
	unnamedMorph3 borderWidth: (0).
	unnamedMorph3 borderStyle2: (#simple).
	unnamedMorph3 borderColor: (Color black).
	unnamedMorph3 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph3.
	panel addMorphBack: unnamedMorph1.
	panel setProperty: #uiClassName toValue: 'UiMessageListDialog'.! !

!UiMessageListDialogUi methodsFor: 'accessing' stamp: 'mt 10/30/2010 18:40:00.183'!
messageList
	"nil"
	
	^ messageList! !

!UiMessageListDialogUi methodsFor: 'accessing' stamp: 'mt 10/30/2010 18:40:00.266'!
okButton
	"nil"
	
	^ okButton! !

UserInterface subclass: #UiSystemProgressMorphUi
	instanceVariableNames: 'view unnamedMorph1 unnamedMorph2 closeBtn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WidgetTools-SystemProgress'!

!UiSystemProgressMorphUi methodsFor: 'accessing' stamp: 'mt 2/20/2011 19:45:23.574'!
closeBtn
	"nil"
	
	^ closeBtn! !

!UiSystemProgressMorphUi methodsFor: 'ui - private' stamp: 'mt 2/20/2011 19:45:23.658'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (403@193).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel cellInset: (4).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (4).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.933)).
	panel color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	panel borderWidth: (1).
	panel borderStyle2: (#simple).
	panel borderColor: ((Color r: 0.6 g: 0.6 b: 0.6)).
	panel setProperty: #objectName toValue: 'panel'.
	view := UiTreeView new.
	view extent: (393@156).
	view position: (5@5).
	view hResizing: (#spaceFill).
	view vResizing: (#spaceFill).
	view cellInset: (0).
	view cellPositioning: (#center).
	view cellSpacing: (#none).
	view layoutInset: (0).
	view listCentering: (#topLeft).
	view listDirection: (#topToBottom).
	view listSpacing: (#none).
	view maxCellSize: (1073741823).
	view minCellSize: (0).
	view wrapCentering: (#topLeft).
	view wrapDirection: (#none).
	view frameFractions: (0@0 corner: 1@1).
	view frameOffsets: (0@0 corner: 0@0).
	view modelClass: (UiSystemProgressModel).
	view horizontalHeaderVisible: (false).
	view verticalHeaderVisible: (false).
	view selectionBehavior: (#selectRows).
	view selectionColor: ((Color r: 0.772 g: 0.858 b: 1.0)).
	view selectionMode: (UiViewSingleSelection).
	view setProperty: #objectName toValue: 'view'.
	panel addMorphBack: view.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (393@22).
	unnamedMorph1 position: (5@165).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#shrinkWrap).
	unnamedMorph1 cellInset: (4).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (0).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#leftToRight).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	unnamedMorph1 color: (Color transparent).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	unnamedMorph2 := UiSpacer new.
	unnamedMorph2 extent: (332@10).
	unnamedMorph2 position: (5@171).
	unnamedMorph2 hResizing: (#spaceFill).
	unnamedMorph2 vResizing: (#rigid).
	unnamedMorph2 cellInset: (4).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (4).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#topToBottom).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 balloonText: (nil).
	unnamedMorph2 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	unnamedMorph2 color: (Color blue).
	unnamedMorph2 borderWidth: (0).
	unnamedMorph2 borderStyle2: (#simple).
	unnamedMorph2 borderColor: (Color black).
	unnamedMorph2 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph2.
	closeBtn := UiPushButton new.
	closeBtn changeTableLayout.
	closeBtn extent: (55@21).
	closeBtn position: (341@165).
	closeBtn hResizing: (#shrinkWrap).
	closeBtn vResizing: (#shrinkWrap).
	closeBtn cellInset: (4).
	closeBtn cellPositioning: (#center).
	closeBtn cellSpacing: (#none).
	closeBtn layoutInset: (2@0 corner: 2@0).
	closeBtn listCentering: (#topLeft).
	closeBtn listDirection: (#leftToRight).
	closeBtn listSpacing: (#none).
	closeBtn maxCellSize: (1073741823).
	closeBtn minCellSize: (0).
	closeBtn wrapCentering: (#topLeft).
	closeBtn wrapDirection: (#none).
	closeBtn frameFractions: (0@0 corner: 1@1).
	closeBtn frameOffsets: (0@0 corner: 0@0).
	closeBtn balloonText: (nil).
	closeBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	closeBtn enabled: (true).
	closeBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons acceptIcon'.
	closeBtn icon: (UiSilkIcons acceptIcon).
	closeBtn text: ('Close').
	closeBtn color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	closeBtn checkable: (false).
	closeBtn checked: (false).
	closeBtn autoExclusive: (false).
	closeBtn setProperty: #objectName toValue: 'closeBtn'.
	unnamedMorph1 addMorphBack: closeBtn.
	panel addMorphBack: unnamedMorph1.
	panel setProperty: #uiClassName toValue: 'UiSystemProgressMorph'.! !

!UiSystemProgressMorphUi methodsFor: 'accessing' stamp: 'mt 2/20/2011 19:45:23.501'!
view
	"nil"
	
	^ view! !

UserInterface subclass: #UiSystemSearchUi
	instanceVariableNames: 'unnamedMorph1 results view unnamedMorph2 searchEdit prevBtn nextBtn concurrentChk unnamedMorph3 statusLbl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WidgetTools-SystemSearch'!

!UiSystemSearchUi methodsFor: 'accessing' stamp: 'mt 2/8/2012 11:07:48.099'!
concurrentChk
	"nil"
	
	^ concurrentChk! !

!UiSystemSearchUi methodsFor: 'ui - private' stamp: 'mt 2/8/2012 11:07:48.129'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (520@297).
	panel position: (0@0).
	panel hResizing: (#shrinkWrap).
	panel vResizing: (#shrinkWrap).
	panel minWidth: (2).
	panel minHeight: (2).
	panel cellInset: (4).
	panel cellPositioning: (#leftCenter).
	panel cellSpacing: (#none).
	panel layoutInset: (4).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.929)).
	panel color: ((Color r: 0.9 g: 0.9 b: 0.9)).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (512@208).
	unnamedMorph1 position: (4@4).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#spaceFill).
	unnamedMorph1 minWidth: (2).
	unnamedMorph1 minHeight: (2).
	unnamedMorph1 cellInset: (4).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (4).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#leftToRight).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	unnamedMorph1 color: (Color transparent).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	results := UiListWidget new.
	results extent: (200@200).
	results position: (8@8).
	results hResizing: (#spaceFill).
	results vResizing: (#spaceFill).
	results minWidth: (200).
	results minHeight: (200).
	results cellInset: (0).
	results cellPositioning: (#center).
	results cellSpacing: (#none).
	results layoutInset: (0).
	results listCentering: (#topLeft).
	results listDirection: (#topToBottom).
	results listSpacing: (#none).
	results maxCellSize: (1073741823).
	results minCellSize: (0).
	results wrapCentering: (#topLeft).
	results wrapDirection: (#none).
	results frameFractions: (0@0 corner: 1@1).
	results frameOffsets: (0@0 corner: 0@0).
	results balloonText: (nil).
	results balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	results widgetResizable: (false).
	results horizontalScrollBarPolicy: (#alwaysOff).
	results verticalScrollBarPolicy: (#asNeeded).
	results outerBorderWidth: (0).
	results scrollBarThickness: (9).
	results modelClass: (UiListWidgetModel).
	results horizontalHeaderVisible: (false).
	results verticalHeaderVisible: (false).
	results selectionBehavior: (#selectRows).
	results selectionColor: ((Color r: 0.772 g: 0.858 b: 1.0)).
	results selectionMode: (UiViewSingleSelection).
	results setProperty: #objectName toValue: 'results'.
	unnamedMorph1 addMorphBack: results.
	view := UiTreeView new.
	view extent: (300@200).
	view position: (212@8).
	view hResizing: (#spaceFill).
	view vResizing: (#spaceFill).
	view minWidth: (300).
	view minHeight: (200).
	view cellInset: (0).
	view cellPositioning: (#center).
	view cellSpacing: (#none).
	view layoutInset: (0).
	view listCentering: (#topLeft).
	view listDirection: (#topToBottom).
	view listSpacing: (#none).
	view maxCellSize: (1073741823).
	view minCellSize: (0).
	view wrapCentering: (#topLeft).
	view wrapDirection: (#none).
	view frameFractions: (0@0 corner: 1@1).
	view frameOffsets: (0@0 corner: 0@0).
	view balloonText: (nil).
	view balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.937)).
	view widgetResizable: (false).
	view horizontalScrollBarPolicy: (#asNeeded).
	view verticalScrollBarPolicy: (#asNeeded).
	view outerBorderWidth: (0).
	view scrollBarThickness: (9).
	view modelClass: (nil).
	view horizontalHeaderVisible: (true).
	view verticalHeaderVisible: (false).
	view selectionBehavior: (#selectRows).
	view selectionColor: ((Color r: 0.772 g: 0.858 b: 1.0)).
	view selectionMode: (UiViewSingleSelection).
	view setProperty: #objectName toValue: 'view'.
	unnamedMorph1 addMorphBack: view.
	panel addMorphBack: unnamedMorph1.
	unnamedMorph2 := UiContainer new.
	unnamedMorph2 changeTableLayout.
	unnamedMorph2 extent: (512@22).
	unnamedMorph2 position: (4@216).
	unnamedMorph2 hResizing: (#spaceFill).
	unnamedMorph2 vResizing: (#shrinkWrap).
	unnamedMorph2 minWidth: (2).
	unnamedMorph2 minHeight: (2).
	unnamedMorph2 cellInset: (10).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (0).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#leftToRight).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 balloonText: (nil).
	unnamedMorph2 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.937)).
	unnamedMorph2 color: (Color transparent).
	unnamedMorph2 borderWidth: (0).
	unnamedMorph2 borderStyle2: (#simple).
	unnamedMorph2 borderColor: (Color black).
	searchEdit := UiLineEdit new.
	searchEdit extent: (377@20).
	searchEdit position: (4@217).
	searchEdit hResizing: (#spaceFill).
	searchEdit vResizing: (#rigid).
	searchEdit minWidth: (2).
	searchEdit minHeight: (2).
	searchEdit cellInset: (0).
	searchEdit cellPositioning: (#center).
	searchEdit cellSpacing: (#none).
	searchEdit layoutInset: (0).
	searchEdit listCentering: (#topLeft).
	searchEdit listDirection: (#topToBottom).
	searchEdit listSpacing: (#none).
	searchEdit maxCellSize: (1073741823).
	searchEdit minCellSize: (0).
	searchEdit wrapCentering: (#topLeft).
	searchEdit wrapDirection: (#none).
	searchEdit frameFractions: (0@0 corner: 1@1).
	searchEdit frameOffsets: (0@0 corner: 0@0).
	searchEdit balloonText: (nil).
	searchEdit balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.937)).
	searchEdit widgetResizable: (false).
	searchEdit horizontalScrollBarPolicy: (#alwaysOff).
	searchEdit verticalScrollBarPolicy: (#alwaysOff).
	searchEdit outerBorderWidth: (1).
	searchEdit scrollBarThickness: (9).
	searchEdit theText: ('').
	searchEdit readOnly: (false).
	searchEdit autoConvert: (false).
	searchEdit autoAccept: (false).
	searchEdit acceptOnFocusLost: (true).
	searchEdit scrollingMode: (#none).
	searchEdit scrollingLimit: (10).
	searchEdit helpText: ('Search...').
	searchEdit hideCursor: (true).
	searchEdit setProperty: #objectName toValue: 'searchEdit'.
	unnamedMorph2 addMorphBack: searchEdit.
	prevBtn := UiPushButton new.
	prevBtn changeTableLayout.
	prevBtn extent: (55@21).
	prevBtn position: (391@216).
	prevBtn hResizing: (#shrinkWrap).
	prevBtn vResizing: (#shrinkWrap).
	prevBtn minWidth: (2).
	prevBtn minHeight: (2).
	prevBtn cellInset: (4).
	prevBtn cellPositioning: (#center).
	prevBtn cellSpacing: (#none).
	prevBtn layoutInset: (2@0 corner: 2@0).
	prevBtn listCentering: (#topLeft).
	prevBtn listDirection: (#leftToRight).
	prevBtn listSpacing: (#none).
	prevBtn maxCellSize: (1073741823).
	prevBtn minCellSize: (0).
	prevBtn wrapCentering: (#topLeft).
	prevBtn wrapDirection: (#none).
	prevBtn frameFractions: (0@0 corner: 1@1).
	prevBtn frameOffsets: (0@0 corner: 0@0).
	prevBtn balloonText: (nil).
	prevBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.937)).
	prevBtn enabled: (true).
	prevBtn setProperty: #iconByDesigner toValue: 'nil'.
	prevBtn icon: (nil).
	prevBtn text: ('Find Prev').
	prevBtn color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	prevBtn checkable: (false).
	prevBtn checked: (false).
	prevBtn autoExclusive: (false).
	prevBtn setProperty: #objectName toValue: 'prevBtn'.
	unnamedMorph2 addMorphBack: prevBtn.
	nextBtn := UiPushButton new.
	nextBtn changeTableLayout.
	nextBtn extent: (56@21).
	nextBtn position: (458@216).
	nextBtn hResizing: (#shrinkWrap).
	nextBtn vResizing: (#shrinkWrap).
	nextBtn minWidth: (2).
	nextBtn minHeight: (2).
	nextBtn cellInset: (4).
	nextBtn cellPositioning: (#center).
	nextBtn cellSpacing: (#none).
	nextBtn layoutInset: (2@0 corner: 2@0).
	nextBtn listCentering: (#topLeft).
	nextBtn listDirection: (#leftToRight).
	nextBtn listSpacing: (#none).
	nextBtn maxCellSize: (1073741823).
	nextBtn minCellSize: (0).
	nextBtn wrapCentering: (#topLeft).
	nextBtn wrapDirection: (#none).
	nextBtn frameFractions: (0@0 corner: 1@1).
	nextBtn frameOffsets: (0@0 corner: 0@0).
	nextBtn balloonText: (nil).
	nextBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.937)).
	nextBtn enabled: (true).
	nextBtn setProperty: #iconByDesigner toValue: 'nil'.
	nextBtn icon: (nil).
	nextBtn text: ('Find Next').
	nextBtn color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	nextBtn checkable: (false).
	nextBtn checked: (false).
	nextBtn autoExclusive: (false).
	nextBtn setProperty: #objectName toValue: 'nextBtn'.
	unnamedMorph2 addMorphBack: nextBtn.
	panel addMorphBack: unnamedMorph2.
	concurrentChk := UiCheckBox new.
	concurrentChk changeTableLayout.
	concurrentChk extent: (139@21).
	concurrentChk position: (4@243).
	concurrentChk hResizing: (#shrinkWrap).
	concurrentChk vResizing: (#shrinkWrap).
	concurrentChk minWidth: (2).
	concurrentChk minHeight: (2).
	concurrentChk cellInset: (4).
	concurrentChk cellPositioning: (#center).
	concurrentChk cellSpacing: (#none).
	concurrentChk layoutInset: (2@0 corner: 2@0).
	concurrentChk listCentering: (#topLeft).
	concurrentChk listDirection: (#leftToRight).
	concurrentChk listSpacing: (#none).
	concurrentChk maxCellSize: (1073741823).
	concurrentChk minCellSize: (0).
	concurrentChk wrapCentering: (#topLeft).
	concurrentChk wrapDirection: (#none).
	concurrentChk frameFractions: (0@0 corner: 1@1).
	concurrentChk frameOffsets: (0@0 corner: 0@0).
	concurrentChk balloonText: (nil).
	concurrentChk balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.937)).
	concurrentChk enabled: (true).
	concurrentChk setProperty: #iconByDesigner toValue: 'nil'.
	concurrentChk icon: (nil).
	concurrentChk text: ('Search in background').
	concurrentChk color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	concurrentChk checkable: (true).
	concurrentChk checked: (false).
	concurrentChk autoExclusive: (false).
	concurrentChk setProperty: #objectName toValue: 'concurrentChk'.
	panel addMorphBack: concurrentChk.
	unnamedMorph3 := UiContainer new.
	unnamedMorph3 extent: (512@2).
	unnamedMorph3 position: (4@268).
	unnamedMorph3 hResizing: (#spaceFill).
	unnamedMorph3 vResizing: (#rigid).
	unnamedMorph3 minWidth: (2).
	unnamedMorph3 minHeight: (2).
	unnamedMorph3 cellInset: (4).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (4).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#topToBottom).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 frameFractions: (0@0 corner: 1@1).
	unnamedMorph3 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph3 balloonText: (nil).
	unnamedMorph3 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.933)).
	unnamedMorph3 color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	unnamedMorph3 borderWidth: (1).
	unnamedMorph3 borderStyle2: (#inset).
	unnamedMorph3 borderColor: (#inset).
	panel addMorphBack: unnamedMorph3.
	statusLbl := UiLabel new.
	statusLbl changeTableLayout.
	statusLbl extent: (41@19).
	statusLbl position: (4@274).
	statusLbl hResizing: (#shrinkWrap).
	statusLbl vResizing: (#shrinkWrap).
	statusLbl minWidth: (2).
	statusLbl minHeight: (2).
	statusLbl cellInset: (0).
	statusLbl cellPositioning: (#center).
	statusLbl cellSpacing: (#none).
	statusLbl layoutInset: (0).
	statusLbl listCentering: (#topLeft).
	statusLbl listDirection: (#leftToRight).
	statusLbl listSpacing: (#none).
	statusLbl maxCellSize: (1073741823).
	statusLbl minCellSize: (0).
	statusLbl wrapCentering: (#topLeft).
	statusLbl wrapDirection: (#none).
	statusLbl frameFractions: (0@0 corner: 1@1).
	statusLbl frameOffsets: (0@0 corner: 0@0).
	statusLbl balloonText: (nil).
	statusLbl balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.937)).
	statusLbl text: ('Status...').
	statusLbl setProperty: #formByDesigner toValue: 'nil'.
	statusLbl form: (nil).
	statusLbl setProperty: #objectName toValue: 'statusLbl'.
	panel addMorphBack: statusLbl.
	panel setProperty: #uiClassName toValue: 'UiSystemSearch'.! !

!UiSystemSearchUi methodsFor: 'accessing' stamp: 'mt 2/8/2012 11:07:48.09'!
nextBtn
	"nil"
	
	^ nextBtn! !

!UiSystemSearchUi methodsFor: 'accessing' stamp: 'mt 2/8/2012 11:07:48.082'!
prevBtn
	"nil"
	
	^ prevBtn! !

!UiSystemSearchUi methodsFor: 'accessing' stamp: 'mt 2/8/2012 11:07:48.057'!
results
	"nil"
	
	^ results! !

!UiSystemSearchUi methodsFor: 'accessing' stamp: 'mt 2/8/2012 11:07:48.074'!
searchEdit
	"nil"
	
	^ searchEdit! !

!UiSystemSearchUi methodsFor: 'accessing' stamp: 'mt 2/8/2012 11:07:48.107'!
statusLbl
	"nil"
	
	^ statusLbl! !

!UiSystemSearchUi methodsFor: 'accessing' stamp: 'mt 2/8/2012 11:07:48.066'!
view
	"nil"
	
	^ view! !

Morph subclass: #UiIconPickerDialog
	instanceVariableNames: 'iconSetCombo iconView infoLabel icon searchInput iconSets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WidgetTools-IconPicker'!

!UiIconPickerDialog commentStamp: 'mt 10/19/2010 11:08:01.295' prior: 0!
A useful dialog to help a developer to choose the right icon.!

!UiIconPickerDialog class methodsFor: 'instance creation' stamp: 'mt 10/14/2010 20:34:30.931'!
open

	self new open.! !

!UiIconPickerDialog methodsFor: 'actions' stamp: 'mt 8/21/2012 10:43:52.829'!
changeIconSet: anIndex

	iconView model iconSet: (iconSets at: anIndex).! !

!UiIconPickerDialog methodsFor: 'actions' stamp: 'mt 5/2/2012 14:03:52.685'!
changeSearch: nameFilter

	Cursor wait showWhile: [
		iconView model nameFilter: nameFilter asString].! !

!UiIconPickerDialog methodsFor: 'actions' stamp: 'mt 10/14/2010 20:47:24.871'!
chooseIcon: aModelIndex

	Clipboard clipboardText: (iconView model codeSnippetFor: aModelIndex).! !

!UiIconPickerDialog methodsFor: 'actions' stamp: 'mt 10/21/2010 22:11:41.636'!
chooseIconAndClose: aModelIndex

	aModelIndex ifNil: [^ self delete].
	icon := (iconView model iconFor: aModelIndex).
	self delete.! !

!UiIconPickerDialog methodsFor: 'actions' stamp: 'mt 10/22/2010 11:24:25.666'!
chooseIconCodeAndClose: aModelIndex

	aModelIndex ifNil: [^ self delete].
	icon := iconView model codeSnippetFor: aModelIndex.
	self delete.! !

!UiIconPickerDialog methodsFor: 'drawing' stamp: 'mt 10/22/2010 11:14:30.318'!
drawOn: aCanvas

	super drawOn: aCanvas.
	self owner == ActiveWorld
		ifTrue: [self drawShadowOn: aCanvas].! !

!UiIconPickerDialog methodsFor: 'drawing' stamp: 'mt 10/22/2010 11:14:03.92'!
drawShadowOn: aCanvas

	aCanvas
		line: self topRight + (0@3)
		to: self bottomRight
		color: (Color black alpha: 0.65).
		
	aCanvas
		line: self bottomLeft + (3@0)
		to: self bottomRight
		color: (Color black alpha: 0.65).
		
	aCanvas
		line: self topRight + (1@4)
		to: self bottomRight + (1@0)
		color: (Color black alpha: 0.5).
		
	aCanvas
		line: self bottomLeft + (4@1)
		to: self bottomRight + (0@1)
		color: (Color black alpha: 0.5).! !

!UiIconPickerDialog methodsFor: 'initialization' stamp: 'mt 8/21/2012 10:43:39.517'!
initialize

	super initialize.
	self initializeIconSets.
	
	iconSetCombo := UiComboBox new hResizing: #spaceFill.
	iconSets do: [:cls | iconSetCombo addText: cls name].
	self connect: iconSetCombo signal: #currentIndexChanged:text: toSelector: #changeIconSet:.
	
	iconView := UiListView new
		listOrientation: #vertical;
		listSpec: ((UiItemViewColumnSpec newFrom: {#icon -> #yourself. "#text -> #yourself." #balloonText -> #yourself})
			iconConverter: [:dict | dict at: #form];
			"textConverter: [:dict | (dict at: #selector) allButLast: 4 ];"
			balloonTextConverter: [:dict | (dict at: #selector) allButLast: 4 "remove icon suffix"]);		
		model: UiIconModel new;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		borderStyle: (BorderStyle inset width: 1).
	iconView verticalScrollBar singleStep: 17.
	self connect: iconView signal: #clicked: toSelector: #chooseIcon:.
	
	searchInput := UiLineEdit new
		helpText: 'Search...'.
	self connect: searchInput signal: #returnPressed: toSelector: #changeSearch:.
	
	self
		color: (Color gray: 0.9);
		changeTableLayout;
		listDirection: #topToBottom;
		layoutInset: 5;
		cellInset: 5;
		cellPositioning: #topLeft.
		
	self
		addMorphBack: (UiLabel new text: 'Select an icon set then pick an icon below. The code to get
the form will be copied into the <b>clipboard</b>.' asHtmlText);
		addMorphBack: iconSetCombo;
		addMorphBack: iconView;
		addMorphBack: searchInput.
		
	"Initial set."
	self changeIconSet: iconSetCombo currentIndex.! !

!UiIconPickerDialog methodsFor: 'initialization' stamp: 'mt 8/21/2012 10:43:08.655'!
initializeIconSets

	iconSets := UiIcons subclasses, {MenuIcons.UiButtonIcons}.! !

!UiIconPickerDialog methodsFor: 'initialization' stamp: 'mt 8/21/2012 10:45:14.525'!
open

	| c |
	c := self color.
	(self openInWindowLabeled: 'Icon Picker')
		extent: 400@300.
		
	self color: c.! !

!UiIconPickerDialog methodsFor: 'geometry' stamp: 'mt 10/22/2010 11:15:55.661'!
outerBounds

	^ self bounds outsetBy: (0@0 corner: 2@2)! !

!UiIconPickerDialog methodsFor: 'initialization' stamp: 'mt 10/22/2010 11:23:55.331'!
pickCodeForIcon

	self submorphs first delete.
	self
		borderWidth: 1;
		borderColor: (Color gray: 0.8) muchDarker;
		extent: 300@200.
	
	self connect: iconView signal: #clicked: toSelector: #chooseIconCodeAndClose:.
	
	self openInWorld.
	[self isInWorld] whileTrue: [ActiveWorld doOneSubCycle].

	^icon! !

!UiIconPickerDialog methodsFor: 'initialization' stamp: 'mt 10/21/2010 22:09:52.839'!
pickIcon

	self submorphs first delete.
	self
		borderWidth: 1;
		borderColor: (Color gray: 0.8) muchDarker;
		extent: 300@200.
	
	self connect: iconView signal: #clicked: toSelector: #chooseIconAndClose:.
	
	self openInWorld.
	[self isInWorld] whileTrue: [ActiveWorld doOneSubCycle].

	^icon! !

Morph subclass: #UiResourceMonitorDialog
	instanceVariableNames: 'view refreshButton gcButton modeChk benchBtn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WidgetTools-ResourceMonitor'!

!UiResourceMonitorDialog class methodsFor: 'instance creation' stamp: 'mt 10/24/2010 12:30:21.819'!
open

	^ self new open! !

!UiResourceMonitorDialog methodsFor: 'initialization' stamp: 'mt 7/18/2012 16:38'!
initialize

	super initialize.
	self initializeUi.
	self showBenchmarks: false.! !

!UiResourceMonitorDialog methodsFor: 'initialization' stamp: 'mt 7/18/2012 16:38'!
initializeUi

	| row |
	refreshButton := UiPushButton new
		icon: UiFugueIcons arrowCircleDouble135Icon;
		text: 'Refresh'.
	gcButton := UiPushButton new
		icon: UiFugueIcons broomIcon;
		text: 'GC'.
	modeChk := UiCheckBox new
		text: 'Show benchmarks'.
	benchBtn := UiPushButton new
		text: 'Bench All'.
	
	view := UiTableView new
		removeVerticalHeader;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		borderStyle: (BorderStyle inset width: 1).
	
	self connect: refreshButton signal: #clicked: toSelector: #refresh.
	self connect: gcButton signal: #clicked: to: Smalltalk selector: #garbageCollect.
	self connect: modeChk signal: #toggled: toSelector: #showBenchmarks:.
	
	self
		color: (Color gray: 0.9);
		changeTableLayout;
		listDirection: #topToBottom;
		layoutInset: 3;
		cellInset: 5.
	
	row := UiContainer new
		changeTableLayout;
		listDirection: #leftToRight;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap.
	row addAllMorphs: {modeChk. UiSpacer new orientation: #horizontal. benchBtn. gcButton. refreshButton}.
	
	self addAllMorphs: {view. row}.! !

!UiResourceMonitorDialog methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2012 13:59:19.261'!
initializeViewWithBenchmarks

	view removeAllColumns.
	view model: UiBenchmarkModel new.
	
	view addColumns: {
		(UiItemViewColumnSpec newFrom: {#headerText -> 'Action'. #text -> #label})
			textConverter: [:label | label asHtmlText].
		(UiItemViewColumnSpec newFrom: {#headerText -> 'TTR+GC'. #text -> #ttr}).
		(UiItemViewColumnSpec newFrom: {#headerText -> 'TTR'. #text -> #ttrNoGC}).
		(UiItemViewColumnSpec newFrom: {
			#headerText -> 'Runs per second'.
			#text -> #bench.
			#menu -> #benchMenu}).
		((UiItemViewColumnSpec newFrom: {
			#headerText -> 'Code'.
			#text -> #code.
			#menu -> #traceMenu})												
			textConverter: [:code | SHTextStylerST80 new styledTextFor: code asText])}.
			
	benchBtn show.
	view setHAlignmentForColumn: 2 to: #right.
	view setHAlignmentForColumn: 3 to: #right.
	view setHAlignmentForColumn: 4 to: #right.
	
	self connect: benchBtn signal: #clicked: to: view model selector: #doAllBenchmarks.! !

!UiResourceMonitorDialog methodsFor: 'as yet unclassified' stamp: 'mt 1/26/2012 11:00:39.805'!
initializeViewWithMonitor

	view removeAllColumns.
	view model: UiResourceMonitorModel new.
	
	view addColumns: {
		(UiItemViewColumnSpec newFrom: {#headerText -> 'Resource'. #text -> #label}).
		(UiItemViewColumnSpec newFrom: {#headerText -> 'Value'. #text -> #value}).
		(UiItemViewColumnSpec newFrom: {
			#headerText -> 'Threshold'.
			#text -> #threshold.
			#icon -> #iconicState}).
		(UiItemViewColumnSpec newFrom: {#headerText -> 'Comments'. #text -> #description})}.
	
	benchBtn hide.
	view setHAlignmentForColumn: 2 to: #right.
	view setHAlignmentForColumn: 3 to: #left.
	view setHAlignmentForColumn: 4 to: #left.! !

!UiResourceMonitorDialog methodsFor: 'initialization' stamp: 'mt 10/24/2010 12:29:56.994'!
open

	| c |
	c := self color.
	(self openInWindowLabeled: 'Ressource Monitor')
		extent: 350@300.
		
	self color: c.! !

!UiResourceMonitorDialog methodsFor: 'as yet unclassified' stamp: 'mt 1/26/2012 10:40:58.817'!
refresh

	self showBenchmarks: modeChk checked.  ! !

!UiResourceMonitorDialog methodsFor: 'as yet unclassified' stamp: 'mt 1/26/2012 10:40:47.095'!
showBenchmarks: aBoolean

	aBoolean
		ifTrue: [self initializeViewWithBenchmarks]
		ifFalse: [self initializeViewWithMonitor]. ! !

Morph subclass: #UiSystemProgressMorph
	instanceVariableNames: 'ui'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WidgetTools-SystemProgress'!

!UiSystemProgressMorph commentStamp: 'mt 8/21/2012 11:05:17.119' prior: 0!
Not functional.!

!UiSystemProgressMorph methodsFor: 'as yet unclassified' stamp: 'mt 2/9/2011 10:10:34.111'!
drawOn: aCanvas

	aCanvas
		fillRectangle: (self bounds translateBy: 2@2)
		color: (Color gray: 0.45).
	super drawOn: aCanvas.! !

!UiSystemProgressMorph methodsFor: 'as yet unclassified' stamp: 'mt 2/20/2011 20:41:37.973'!
initialize

	super initialize.
	ui := UiSystemProgressMorphUi new.
	ui setupUi: self.
	ui view model: UiSystemProgressModel instance.
	
	ui view setHAlignmentForColumn: 2 to: #right.
	ui view moveColumn: 2 to: 1.
	
	ui view animated: false.  
	
	self connect: ui view model signal: #rowsInsertedFor:from:to: to: ui view selector: #expandIndex:.
	self connect: ui view model signal: #rowsInsertedFor:from:to: to: ui view selector: #scrollToBottom.
	
	self connect: ui view model signal: #nodeClosed: to: ui view selector: #collapseIndex:.
	
"	self connect: ui view model signal: #rowsInsertedFor:from:to: toSelector: #redraw."
	self connect: ui view model signal: #rowsChangedFor:from:to: to: ui view selector: #redraw.
	
	self connect: ui closeBtn signal: #clicked: toSelector: #delete.
	self connect: ui closeBtn signal: #clicked: to: UiSystemProgressModel selector: #reset.! !

!UiSystemProgressMorph methodsFor: 'as yet unclassified' stamp: 'mt 2/9/2011 10:08:52.333'!
outerBounds

	^ self bounds outsetBy: (0@0 corner: 2@2)! !

!UiSystemProgressMorph methodsFor: 'as yet unclassified' stamp: 'mt 2/17/2011 20:11:47.601'!
ui

	^ ui! !

Morph subclass: #UiWorldToolbar
	instanceVariableNames: 'backgroundColor cv vb'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WidgetTools-WorldToolbar'!

!UiWorldToolbar class methodsFor: 'as yet unclassified' stamp: 'mt 12/23/2011 11:08:10.922'!
open

	| spacer |
	(World submorphs detect: [:m | m isKindOf: self] ifNone: [])
		ifNotNil: [:tool | tool updateButtons].

	spacer := ActiveWorld mainDockingBars first submorphs detect: [:m | m isAlignmentMorph].
	ActiveWorld mainDockingBars first
		addMorph: self new inFrontOf: spacer.! !

!UiWorldToolbar methodsFor: 'private' stamp: 'mt 5/6/2011 11:37:40.808'!
cvInstall

	| wc |
	(UserDialogBoxMorph confirm: 'Do you really want to install CV?')
		ifFalse: [^ self].
		
	"Start PolySource."
	"World psInstall."

	"Start ContinousVersioning"
	cv := World cvInstall.

	"Add new working copy."
	wc := cv startVersioning: PsActiveCodeBase value.
	World psRebaseTo: wc.

	"Open version bar."
	vb := CvVersionBar controller: cv.
	vb openInWorld.! !

!UiWorldToolbar methodsFor: 'private' stamp: 'mt 5/6/2011 11:37:49.75'!
cvUninstall

	(UserDialogBoxMorph confirm: 'Do you really want to uninstall CV?')
		ifFalse: [^ self].

	"Rebase to original."
	World psRebaseTo: World polySource codeBases second.
	
	"Remove version bar."
	vb delete.
	vb := nil.
	
	"Stop ContinousVersioning."
	World cvUninstall.
	cv := nil.
	
	"Stop PolySource."
	"World psUninstall."! !

!UiWorldToolbar methodsFor: 'private' stamp: 'mt 8/21/2012 09:21:18.852'!
definitions

	^ {
	nil.
	{'Save'. UiSilkIcons diskIcon. Smalltalk. #saveSession. #iconOnly}.
	{'Quit'. UiSilkIcons doorInIcon. self. #quitSession. #iconOnly}.
	nil.
	{'Workspace'. UiSilkIcons applicationXpTerminalIcon. Workspace. #open. #iconOnly}.
	{'Transcript'. UiSilkIcons applicationViewListIcon. Transcript. #open. #iconOnly}.
	{'System Browser'. UiSilkIcons folderExploreIcon. Smalltalk at: #OBSystemBrowser ifAbsent: []. #open. #iconOnly}.
	{'Monticello Browser'. UiSilkIcons worldIcon. MCWorkingCopyBrowser. #open. #iconOnly}.
	{'Test Runner'. UiFugueIcons clipboardTaskIcon. "UiFugueIcons tickShieldIcon." TestRunner. #open. #iconOnly}.
	{'Preferences'. UiSilkIcons cogIcon. PreferenceBrowser. #open. #iconOnly}.
	nil.
	{'Start Profiler'. UiFugueIcons alarmClockSelectIcon. self. #startMessageTally. #iconOnly}.
	{'Collect Garbage'. UiFugueIcons broomIcon. Smalltalk. #garbageCollect. #iconOnly}.
	{'Close all debuggers'. UiSilkIcons bugDeleteIcon. Utilities. #closeAllDebuggers. #iconOnly}.
	{'Set author initials.'. UiSilkIcons vcardEditIcon. Utilities. #setAuthorInitials. #iconOnly}.
	nil.
	{'Morphic Designer'. UiFugueIcons leafIcon. Smalltalk at: #UiDesigner ifAbsent: []. #open. #iconOnly}.
	{'Ressource Monitor'. UiSilkIcons chartBarIcon. Smalltalk at: #UiResourceMonitorDialog ifAbsent: []. #open. #iconOnly}.
	{'Icon Picker'. UiSilkIcons folderHeartIcon. Smalltalk at: #UiIconPickerDialog ifAbsent: []. #open. #iconOnly}.
	{'Vivide'. UiFugueIcons lightningIcon. Smalltalk at: #Vivide ifAbsent: []. #open. #iconOnly}.
"	nil.
	{'Install CV'. UiSilkIcons controlPlayBlueIcon. self. #cvInstall. #textBesidesIcon}.
	{'Uninstall CV'. UiSilkIcons controlStopBlueIcon. self. #cvUninstall. #textBesidesIcon}."
	nil.
	{'Refresh Toolbar'. UiSilkIcons arrowRefreshSmallIcon. self. #updateButtons. #iconOnly}.
	{'Help Browser'. UiSilkIcons helpIcon. Smalltalk at: #HelpBrowser ifAbsent: []. #open. #iconOnly}.
	}! !

!UiWorldToolbar methodsFor: 'drawing' stamp: 'mt 12/16/2011 11:58:38.916'!
gradient

	^ (GradientFillStyle ramp: {
		0.0 -> (self color alpha: 0.3).
		0.5 -> self color.
		1.0 -> (self color alpha: 0.3)})
	origin: self topLeft;
	direction: 0 @ self height! !

!UiWorldToolbar methodsFor: 'drawing' stamp: 'mt 12/16/2011 12:01:21.416'!
gradient: aColor

	^ (GradientFillStyle ramp: {
		0.1 -> (aColor alpha: 0.0).
		0.5 -> aColor.
		0.9 -> (aColor alpha: 0.0)})
	origin: self topLeft;
	direction: 0 @ self height! !

!UiWorldToolbar methodsFor: 'initialization' stamp: 'mt 12/23/2011 11:03:18.287'!
initialize

	super initialize.
	
	self
		changeTableLayout;
		vResizing: #shrinkWrap;
		hResizing: #shrinkWrap;
		listDirection: #leftToRight;
		borderWidth: 0;
		color: Color transparent;
		height: 22;
		layoutInset: (0@1 corner: 0@0);
		cellInset: 5.
	
	self updateButtons.! !

!UiWorldToolbar methodsFor: 'as yet unclassified' stamp: 'mt 12/19/2011 15:25:01.062'!
keyStroke: evt

	"Nothing."! !

!UiWorldToolbar methodsFor: 'private' stamp: 'mt 12/14/2010 11:42:58.901'!
quitSession

	Smalltalk
		snapshot: (UserDialogBoxMorph 
			confirm: 'Save changes before quitting?' translated 
			orCancel: [^ self]
			at: World center)
		andQuit: true! !

!UiWorldToolbar methodsFor: 'private' stamp: 'mt 12/16/2011 12:01:34.04'!
separator

	^ UiContainer new
		vResizing: #spaceFill;
		hResizing: #rigid;
		fillStyle: (self gradient: Color gray);
		layoutInset: 0;
		cellInset: 0;
		width: 1! !

!UiWorldToolbar methodsFor: 'private' stamp: 'mt 12/14/2010 11:37:28.37'!
startMessageTally
	(self confirm: 'MessageTally will start now,
and stop when the cursor goes
to the top of the screen') ifTrue:
		[MessageTally spyOn:
			[[Sensor peekMousePt y > 0] whileTrue: [World doOneCycle]]]! !

!UiWorldToolbar methodsFor: 'private' stamp: 'mt 12/23/2011 11:11:18.748'!
updateButtons

	| group |
	self removeAllMorphs.

	self definitions do: [:definition |
		| button |
		definition
			ifNil: [group ifNotNil: [self addMorphBack: group]. self addMorphBack: self separator. group := nil.]
			ifNotNil: [
				group ifNil: [group := UiContainer new changeTableLayout; listDirection: #leftToRight; hResizing: #shrinkWrap; vResizing: #shrinkWrap; layoutInset: 0; cellInset: 0.].
				button := UiToolButton new
					text: definition first;
					icon: definition second;
					layoutInset: (2@2 corner: 2@2);
					balloonText: definition first;
					buttonStyle: definition fifth;
					autoRaise: true.
				
				definition third
					ifNil: [button enabled: false]
					ifNotNil: [:receiver | self connect: button signal: #clicked: to: definition third selector: definition fourth].
				group addMorphBack: button]].
		
	self addMorphBack: group.! !

!UiWorldToolbar methodsFor: 'private' stamp: 'mt 12/14/2010 13:31:12.683'!
updateColor

	"No change here."! !

Object subclass: #UiBenchmarkModel
	uses: TUiItemModel
	instanceVariableNames: 'results children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WidgetTools-ResourceMonitor'!

UiBenchmarkModel class
	uses: TUiItemModel classTrait
	instanceVariableNames: ''!

!UiBenchmarkModel methodsFor: 'item model - hierarchy' stamp: 'mt 5/2/2012 13:55:50.251'!
childAt: index inGroup: groupName
		
	^ self children at: index ifAbsentPut: [
		UiBenchmarkNode new
			at: #label put: ((self data at: index) at: 1);
			code: ((self data at: index) at: 2);
			updateTtr;
			updateTtrNoGC]! !

!UiBenchmarkModel methodsFor: 'as yet unclassified' stamp: 'mt 1/26/2012 10:45:54.658'!
children
	"Just a cache. See #childAt:."

	^ children ifNil: [children := OrderedCollection new]! !

!UiBenchmarkModel methodsFor: 'specs' stamp: 'mt 8/21/2012 11:02:00.648'!
data

	^ {
		{'Create morph'. '[Morph new]'}.
		{'Create iconic button'. '[IconicButton new]'}.
		{'Create <b>ui</b> push button'. '[UiPushButton new icon: UiSilkIcons diskIcon]'}.
		{'Create scroll bar'. '[ScrollBar new]'}.
		{'Create <b>ui</b> scroll bar'. '[UiScrollBar new]'}.
		{'Create scroll pane'. '[ScrollPane new]'}.
		{'Create <b>ui</b> scroll area'. '[UiScrollArea new]'}.
		{'Create pluggable text morph'. '[PluggableTextMorph new]'}.
		{'Create <b>ui</b> text edit'. '[UiTextEdit new]'}.
		{'Create pluggable list'. '[PluggableListMorph new]'}.
		{'Create <b>ui</b> list view'. '[UiListView new]'}.
	}! !

!UiBenchmarkModel methodsFor: 'as yet unclassified' stamp: 'mt 8/21/2012 11:03:23.889'!
doAllBenchmarks

	Cursor wait showWhile: [
		(1 to: self childCount)
			do: [:i | (self childAt: i inGroup: #data) updateBench]
			displayingProgress: [:i | (self childAt: i inGroup: #data) code]].! !

!UiBenchmarkModel methodsFor: 'item model - hierarchy' stamp: 'mt 5/2/2012 13:55:36.894'!
groups
	
	^ #(data)! !

Object subclass: #UiIconModel
	uses: TUiItemModel
	instanceVariableNames: 'iconSet showText nameFilter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WidgetTools-IconPicker'!

!UiIconModel commentStamp: 'mt 10/14/2010 19:53:08.979' prior: 0!
Supports all subclasses of UiIcons as #iconSet.!

UiIconModel class
	uses: TUiItemModel classTrait
	instanceVariableNames: ''!

!UiIconModel class methodsFor: 'examples' stamp: 'mt 1/23/2012 15:54:00.091'!
ex01silk

	UiListView new
		listOrientation: #vertical;
		listSpec: ((UiItemViewColumnSpec newFrom: {#icon -> #yourself. #balloonText -> #yourself})
			iconConverter: [:dict | dict at: #form];
			balloonTextConverter: [:dict | (dict at: #selector) allButLast: 4 "remove iconsuffix"]);
		model: (UiIconModel new iconSet: UiSilkIcons);
		topLeft: 50@50;
		extent: 600@300;
		openInWorld.! !

!UiIconModel class methodsFor: 'examples' stamp: 'mt 1/23/2012 15:53:54.105'!
ex02silkWithText

	UiListView new
		listOrientation: #vertical;
		listSpec: ((UiItemViewColumnSpec newFrom: {#icon -> #yourself. #text -> #yourself. #balloonText -> #yourself})
			iconConverter: [:dict | dict at: #form];
			textConverter: [:dict | (dict at: #selector) allButLast: 4 "remove icon suffix"];
			balloonTextConverter: [:dict | (dict at: #selector) allButLast: 4 "remove icon suffix"]);
		model: (UiIconModel new iconSet: UiSilkIcons);
		topLeft: 50@50;
		extent: 600@300;
		openInWorld.! !

!UiIconModel methodsFor: 'item model - hierarchy' stamp: 'mt 5/2/2012 14:02:17.543'!
childAt: index inGroup: groupName
		
	^ UiPropertyItemNode new
		at: #selector put: (self iconSelectors at: index);
		at: #form put: (self iconSet perform: (self iconSelectors at: index));
		yourself! !

!UiIconModel methodsFor: 'accessing' stamp: 'mt 1/23/2012 15:11:17.298'!
codeSnippetFor: aDict

	aDict ifNil: [^ ''].
	
	^ self iconSet name, ' ', (aDict at: #selector)! !

!UiIconModel methodsFor: 'item model - hierarchy' stamp: 'mt 5/2/2012 14:02:02.374'!
groups
	
	^ #(iconSelectors)! !

!UiIconModel methodsFor: 'accessing' stamp: 'mt 8/16/2012 11:51:36.456'!
iconSelectors

	self iconSet ifNil: [^ #()].
	^ (self iconSet class organization categories select: [:cat | cat includesSubString: 'accessing'])
		gather: [:cat | (self iconSet class organization listAtCategoryNamed: cat)
			select: [:iconName | self nameFilter isNil or: [iconName asLowercase includesSubString: self nameFilter asLowercase]]]! !

!UiIconModel methodsFor: 'accessing' stamp: 'mt 10/14/2010 19:45:12.099'!
iconSet

	^ iconSet! !

!UiIconModel methodsFor: 'accessing' stamp: 'mt 1/23/2012 15:10:09.742'!
iconSet: anIconSet

	iconSet := anIconSet.
	self modelReset.! !

!UiIconModel methodsFor: 'accessing' stamp: 'mt 11/14/2010 15:24:39.02'!
nameFilter

	^ nameFilter! !

!UiIconModel methodsFor: 'accessing' stamp: 'mt 1/23/2012 15:10:27.836'!
nameFilter: aString

	nameFilter := aString ifEmpty: [nil].
	self modelReset.! !

Object subclass: #UiResourceMonitorModel
	uses: TUiItemModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WidgetTools-ResourceMonitor'!

UiResourceMonitorModel class
	uses: TUiItemModel classTrait
	instanceVariableNames: ''!

!UiResourceMonitorModel methodsFor: 'item model - hierarchy' stamp: 'mt 5/2/2012 13:55:15.414'!
childAt: index inGroup: groupName
	
	^ UiResourceMonitorNode new
		at: #label put: ((self data at: index) at: 1);
		at: #value put: ((self data at: index) at: 2) value;
		at: #threshold put: ((self data at: index) at: 3);
		at: #description put: ((self data at: index) at: 4);
		yourself! !

!UiResourceMonitorModel methodsFor: 'specs' stamp: 'mt 1/25/2012 13:54:18.978'!
data

	^ {
		{'world submorphs'. [ActiveWorld submorphs size]. nil. 'The number of all submorphs in the active world (<b>PasteUpMorph</b>)' asHtmlText}.
		{'event handlers'. [EventHandler allInstances size]. 2000. 'The number of all <b>EventHandler</b> instances.' asHtmlText}.
		{'signal emitters'. [SignalConnectionsRepository instance size]. 500. 'The number of all registered objects that have signals connected to somewhere.'}.
		{'event signal emitters'. [SignalConnectionsRepository instance keys count: [:key | key isKindOf: UiEventHandler]]. 500. 'The number of all <b>UiEventHandler</b> signal emitters.' asHtmlText}.
		{'icons'. Form allInstances count: [:f | f extent = (16@16)]. nil. 'The number of all 16x16 forms.'}.
		{'packages'. [PackageOrganizer default packages size]. nil. 'The number of all packages in this image.'}.
		{'classes'. [Smalltalk allClasses size]. nil. 'The number of all classes in this image.'}.
		{'traits'. [Smalltalk allTraits size]. nil. 'The number of all traits in this image.'}.
		{'system change sends'. [((SystemChangeNotifier uniqueInstance instVarNamed: #eventSource) actionMap values collect: [:list | list size]) sum]. nil. 'The number of all targets if a system change event occurs.'}.
		{'running animations'. [AnimAnimationRegistry main graphicsAnimations count: [:anim | anim isRunning]]. 10. 'The number of all running animations.'}.
		{'finished animations'. [AnimAnimationRegistry main graphicsAnimations count: [:anim | anim finishedOnce]]. 100. 'The number of all finished animations which where not deleted yet.'}}! !

!UiResourceMonitorModel methodsFor: 'item model - hierarchy' stamp: 'mt 5/2/2012 13:54:59.863'!
groups
	
	^ #(data)! !

Object subclass: #UiSmalltalkModel
	uses: TUiItemModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WidgetTools-SystemSearch'!

!UiSmalltalkModel commentStamp: 'mt 10/19/2010 11:04:26.59' prior: 0!
More complex model to navigate the Smalltalk system structure. See class-side examples.!

UiSmalltalkModel class
	uses: TUiItemModel classTrait
	instanceVariableNames: ''!

UiSmalltalkModel subclass: #UiSmalltalkCategoryNode
	instanceVariableNames: 'category prefix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WidgetTools-SystemSearch'!

!UiSmalltalkCategoryNode methodsFor: 'comparing' stamp: 'mt 2/7/2012 15:49:39.519'!
= aNode

	^ self species = aNode species
		and: [self category = aNode category]! !

!UiSmalltalkCategoryNode methodsFor: 'accessing' stamp: 'mt 1/23/2012 16:17:04.93'!
category
	^ category! !

!UiSmalltalkCategoryNode methodsFor: 'accessing' stamp: 'mt 1/23/2012 16:17:04.962'!
category: anObject
	category := anObject! !

!UiSmalltalkCategoryNode methodsFor: 'item model - hierarchy' stamp: 'mt 4/27/2012 11:46:03.253'!
childAt: index inGroup: groupName

	^ UiSmalltalkClassNode new
		theClass: (Smalltalk at: (self classNames at: index))! !

!UiSmalltalkCategoryNode methodsFor: 'item model - hierarchy' stamp: 'mt 4/27/2012 11:45:23.541'!
classNames

	^ (SystemOrganization listAtCategoryNamed: self category)! !

!UiSmalltalkCategoryNode methodsFor: 'item model - hierarchy' stamp: 'mt 4/27/2012 11:45:33.037'!
groups

	^ #(classNames)! !

!UiSmalltalkCategoryNode methodsFor: 'comparing' stamp: 'mt 2/7/2012 15:49:53.88'!
hash

	^ self species hash bitXor: [self category hash]! !

!UiSmalltalkCategoryNode methodsFor: 'accessing' stamp: 'mt 2/6/2012 18:02:03.201'!
label

	^ self category! !

!UiSmalltalkCategoryNode methodsFor: 'accessing' stamp: 'mt 1/23/2012 16:19:36.923'!
prefix
	^ prefix! !

!UiSmalltalkCategoryNode methodsFor: 'accessing' stamp: 'mt 1/23/2012 16:19:36.955'!
prefix: anObject
	prefix := anObject! !

UiSmalltalkModel subclass: #UiSmalltalkClassNode
	instanceVariableNames: 'theClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WidgetTools-SystemSearch'!

!UiSmalltalkClassNode methodsFor: 'comparing' stamp: 'mt 2/7/2012 15:50:22.792'!
= aNode

	^ self species = aNode species
		and: [self theClass = aNode theClass]! !

!UiSmalltalkClassNode methodsFor: 'item model - hierarchy' stamp: 'mt 4/27/2012 11:46:48.356'!
childAt: index inGroup: groupname

	^ UiSmalltalkProtocolNode new
		protocol: (self protocols at: index);
		organization: self theClass organization! !

!UiSmalltalkClassNode methodsFor: 'item model - hierarchy' stamp: 'mt 4/27/2012 11:46:30.216'!
groups

	^ #(protocols)! !

!UiSmalltalkClassNode methodsFor: 'comparing' stamp: 'mt 2/7/2012 15:50:37.179'!
hash

	^ self species hash bitXor: [self theClass hash]! !

!UiSmalltalkClassNode methodsFor: 'accessing' stamp: 'mt 2/6/2012 18:02:10.244'!
label

	^ self theClass name! !

!UiSmalltalkClassNode methodsFor: 'item model - hierarchy' stamp: 'mt 4/27/2012 11:46:24.747'!
protocols

	^ self theClass organization categories! !

!UiSmalltalkClassNode methodsFor: 'accessing' stamp: 'mt 1/23/2012 16:16:52.845'!
theClass
	^ theClass! !

!UiSmalltalkClassNode methodsFor: 'accessing' stamp: 'mt 1/23/2012 16:16:52.873'!
theClass: anObject
	theClass := anObject! !

UiSmalltalkModel subclass: #UiSmalltalkMethodNode
	instanceVariableNames: 'theClass selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WidgetTools-SystemSearch'!

!UiSmalltalkMethodNode methodsFor: 'comparing' stamp: 'mt 2/7/2012 15:51:20.818'!
= aNode

	^ self species = aNode species
		and: [self theClass = aNode theClass]
		and: [self selector = aNode selector]! !

!UiSmalltalkMethodNode methodsFor: 'item model - hierarchy' stamp: 'mt 4/27/2012 11:48:10.652'!
groups

	 ^ #()! !

!UiSmalltalkMethodNode methodsFor: 'comparing' stamp: 'mt 2/7/2012 15:51:46.422'!
hash

	^ [self species hash
		bitXor: [self theClass hash]]
		bitXor: [self selector hash]! !

!UiSmalltalkMethodNode methodsFor: 'accessing' stamp: 'mt 2/6/2012 18:02:20.077'!
label

	^ self selector! !

!UiSmalltalkMethodNode methodsFor: 'accessing' stamp: 'mt 1/23/2012 16:16:20.707'!
selector
	^ selector! !

!UiSmalltalkMethodNode methodsFor: 'accessing' stamp: 'mt 1/23/2012 16:16:20.739'!
selector: anObject
	selector := anObject! !

!UiSmalltalkMethodNode methodsFor: 'accessing' stamp: 'mt 2/7/2012 15:50:55.076'!
theClass
	^ theClass! !

!UiSmalltalkMethodNode methodsFor: 'accessing' stamp: 'mt 2/7/2012 15:50:55.109'!
theClass: anObject
	theClass := anObject! !

!UiSmalltalkModel class methodsFor: 'examples' stamp: 'mt 1/23/2012 17:18:38.137'!
ex01iconicList

	UiListView new
		listOrientation: #vertical;
		listSpec: ((UiItemViewColumnSpec newFrom: {#text -> #yourself. #icon -> #yourself})
			textConverter: [:node | node package name];
			iconConverter: [:node | UiSilkIcons packageIcon];
			itemOrientation: #vertical);
		model: UiSmalltalkModel new;
		hAlignment: #center;		
		topLeft: 50@50;
		extent: 600@300;
		openInWorld.! !

!UiSmalltalkModel class methodsFor: 'examples' stamp: 'mt 1/23/2012 17:16:07.248'!
ex02tree

	UiTreeView new
		addColumn: ((UiItemViewColumnSpec newFrom: {#text -> #yourself. #icon -> #yourself})
			textConverter: [:node | ((Dictionary newFrom: {
				UiSmalltalkPackageNode -> [node package name].
				UiSmalltalkCategoryNode -> [node category].
				UiSmalltalkClassNode -> [node theClass name].
				UiSmalltalkProtocolNode -> [node protocol].
				UiSmalltalkMethodNode -> [node selector]}) at: node class) value];
			iconConverter: [:node | (node isKindOf: UiSmalltalkPackageNode) ifTrue: [UiSilkIcons packageIcon] ifFalse: []]);
		addColumn: ((UiItemViewColumnSpec newFrom: {#text -> #childCount})
			textConverter: [:integer | ('<font color="#555555">', integer asString, '</font>') asHtmlText]);
		addColumn: ((UiItemViewColumnSpec newFrom: {#text -> #yourself})
			textConverter: [:node | ('<font color="#555555">{1}</font>' format: {((Dictionary newFrom: {
				UiSmalltalkPackageNode -> ['package'].
				UiSmalltalkCategoryNode -> ['system category'].
				UiSmalltalkClassNode -> ['class'].
				UiSmalltalkProtocolNode -> ['protocol'].
				UiSmalltalkMethodNode -> ['method']}) at: node class) value}) asHtmlText]);
		model: UiSmalltalkModel new;
		topLeft: 50@50;
		extent: 600@300;
		openInWorld.! !

!UiSmalltalkModel class methodsFor: 'examples' stamp: 'mt 1/23/2012 17:26:40.552'!
ex03table

	UiTableView new
		addColumn: ((UiItemViewColumnSpec newFrom: {#text -> #yourself. #icon -> #yourself})
			textConverter: [:node | node package name];
			iconConverter: [:node | UiSilkIcons packageIcon]);
		addColumn: ((UiItemViewColumnSpec newFrom: {#text -> #childCount})
			textConverter: [:integer | ('<font color="#555555">', integer asString, '</font>') asHtmlText]);
		addColumn: ((UiItemViewColumnSpec newFrom: {#text -> #yourself})
			textConverter: [:node | '<font color="#555555">package</font>' asHtmlText]);
		model: UiSmalltalkModel new;
		setHAlignmentForColumn: 2 to: #right;
		setHAlignmentForColumn: 3 to: #center;
		topLeft: 50@50;
		extent: 600@300;
		openInWorld.! !

!UiSmalltalkModel class methodsFor: 'examples' stamp: 'mt 1/23/2012 17:27:38.833'!
ex04simpleList

	UiListView new
		listSpec: ((UiItemViewColumnSpec newFrom: {#text -> #yourself. #icon -> #yourself})
			textConverter: [:node | node package name];
			iconConverter: [:node | UiSilkIcons packageIcon]);
		model: UiSmalltalkModel new;
		topLeft: 50@50;
		extent: 600@300;
		openInWorld.! !

!UiSmalltalkModel class methodsFor: 'examples' stamp: 'mt 1/23/2012 17:28:16.033'!
ex05horizontalList

	UiListView new
		listSpec: ((UiItemViewColumnSpec newFrom: {#text -> #yourself. #icon -> #yourself})
			textConverter: [:node | node package name];
			iconConverter: [:node | UiSilkIcons packageIcon]);
		listOrientation: #horizontal;
		model: UiSmalltalkModel new;
		topLeft: 50@50;
		extent: 600@300;
		openInWorld.! !

!UiSmalltalkModel methodsFor: 'item model - hierarchy' stamp: 'mt 4/27/2012 11:55:02.966'!
childAt: index inGroup: groupName
	
	^ UiSmalltalkPackageNode new
		package: ((self perform: groupName) at: index)! !

!UiSmalltalkModel methodsFor: 'item model - hierarchy' stamp: 'mt 4/27/2012 11:54:37.22'!
groups
	
	^ #(packagesForSeaside packagesForOtherProjects)! !

!UiSmalltalkModel methodsFor: 'initialization' stamp: 'mt 10/14/2010 19:36:09.409'!
initialize

	"SystemChangeNotifier uniqueInstance
		notify: self ofAllSystemChangesUsing: #processNotification:."! !

!UiSmalltalkModel methodsFor: 'testing' stamp: 'mt 2/6/2012 17:01:19.951'!
isPackageNode

	^ false! !

!UiSmalltalkModel methodsFor: 'accessing' stamp: 'mt 2/6/2012 18:01:55.475'!
label

	self subclassResponsibility.! !

!UiSmalltalkModel methodsFor: 'accessing' stamp: 'mt 8/2/2012 10:34:16.902'!
packagesForOtherProjects

	^ PackageOrganizer default packages reject: [:pkg | pkg name beginsWith: #Seaside]! !

!UiSmalltalkModel methodsFor: 'accessing' stamp: 'mt 8/2/2012 10:34:19.216'!
packagesForSeaside

	^ PackageOrganizer default packages select: [:pkg | pkg name beginsWith: #Seaside]! !

!UiSmalltalkModel methodsFor: 'notifications' stamp: 'mt 10/14/2010 11:43:56.986'!
processNotification: anEvent

	| pkg pkgIndex sysIndex classIndex |
	(anEvent itemKind ~= #category and: [anEvent itemKind ~= #class])
		ifTrue: [^ self].
	
	pkg := PackageOrganizer default
		packageOfSystemCategory: anEvent itemCategory
		ifNone: [^ self].
	pkgIndex := (UiSimpleModelIndex
		row: (PackageOrganizer default packages indexOf: pkg)
		column: 1)
		model: self;
		setProperty: #package toValue: pkg.
	sysIndex := self
		indexRow: (pkg systemCategories indexOf: anEvent itemCategory)
		column: 1
		parent: pkgIndex.
	classIndex := self
		indexRow: ((SystemOrganization listAtCategoryNamed: anEvent itemCategory) indexOf: anEvent itemClass name)
		column: 1
		parent: sysIndex.
	
	anEvent itemKind = #category ifTrue: [
		anEvent isAdded ifTrue: [
			self rowsInsertedFor: pkgIndex from: sysIndex row to: sysIndex row.
			self rowsChangedFor: nil from: pkgIndex row to: pkgIndex row].
		anEvent isRemoved ifTrue: [
			self rowsRemovedFor: pkgIndex from: sysIndex row to: sysIndex row.
			self rowsChangedFor: nil from: pkgIndex row to: pkgIndex row].
		anEvent isRenamed ifTrue: [
			sysIndex := self
				indexRow: (pkg systemCategories indexOf: anEvent newName)
				column: 1
				parent: pkgIndex.
			self rowsChangedFor: pkgIndex from: sysIndex row to: sysIndex row]].

	anEvent itemKind = #class ifTrue: [
		anEvent isAdded ifTrue: [
			self rowsInsertedFor: sysIndex from: classIndex row to: classIndex row.
			self rowsChangedFor: pkgIndex from: sysIndex row to: sysIndex row].
		anEvent isRenamed ifTrue: [
			self rowsChangedFor: sysIndex from: classIndex row to: classIndex row].
		anEvent isRemoved ifTrue: [
			self rowsRemovedFor: sysIndex from: classIndex row to: classIndex row.
			self rowsChangedFor: pkgIndex from: sysIndex row to: sysIndex row]
		].
	
	anEvent itemKind = #method ifTrue: [
		].! !

UiSmalltalkModel subclass: #UiSmalltalkPackageNode
	instanceVariableNames: 'package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WidgetTools-SystemSearch'!

!UiSmalltalkPackageNode methodsFor: 'comparing' stamp: 'mt 2/6/2012 17:29:57.178'!
= aNode

	^ self species = aNode species
		and: [self package = aNode package]! !

!UiSmalltalkPackageNode methodsFor: 'item model - hierarchy' stamp: 'mt 4/27/2012 11:44:51.231'!
childAt: index inGroup: groupName

	^ UiSmalltalkCategoryNode new
		category: (self systemCategories at: index);
		prefix: self package systemCategoryPrefix! !

!UiSmalltalkPackageNode methodsFor: 'item model - hierarchy' stamp: 'mt 4/27/2012 11:44:22.595'!
groups

	^ #(systemCategories)! !

!UiSmalltalkPackageNode methodsFor: 'comparing' stamp: 'mt 2/6/2012 17:30:21.507'!
hash

	^ self species hash bitXor: self package hash! !

!UiSmalltalkPackageNode methodsFor: 'testing' stamp: 'mt 2/6/2012 17:01:30.321'!
isPackageNode

	^ true! !

!UiSmalltalkPackageNode methodsFor: 'accessing' stamp: 'mt 2/6/2012 18:02:26.178'!
label

	^ self package name! !

!UiSmalltalkPackageNode methodsFor: 'accessing' stamp: 'mt 1/23/2012 16:15:27.765'!
package
	^ package! !

!UiSmalltalkPackageNode methodsFor: 'accessing' stamp: 'mt 1/23/2012 16:15:27.791'!
package: anObject
	package := anObject! !

!UiSmalltalkPackageNode methodsFor: 'item model - hierarchy' stamp: 'mt 4/27/2012 11:44:11.264'!
systemCategories

	^ self package systemCategories! !

UiSmalltalkModel subclass: #UiSmalltalkProtocolNode
	instanceVariableNames: 'protocol organization'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WidgetTools-SystemSearch'!

!UiSmalltalkProtocolNode methodsFor: 'comparing' stamp: 'mt 2/7/2012 15:54:27.603'!
= aNode

	^ self species = aNode species
		and: [self organization = aNode organization]
		and: [self protocol = aNode protocol]! !

!UiSmalltalkProtocolNode methodsFor: 'item model - hierarchy' stamp: 'mt 4/27/2012 11:47:38.174'!
childAt: index inGroup: groupName

	^ UiSmalltalkMethodNode new
		theClass: self organization subject;
		selector: (self messages at: index)! !

!UiSmalltalkProtocolNode methodsFor: 'item model - hierarchy' stamp: 'mt 4/27/2012 11:47:18.768'!
groups

	^ #(messages)! !

!UiSmalltalkProtocolNode methodsFor: 'comparing' stamp: 'mt 2/7/2012 15:54:54.011'!
hash

	^ [self species hash
		bitXor: [self organization hash]]
		bitXor: [self protocol hash]! !

!UiSmalltalkProtocolNode methodsFor: 'accessing' stamp: 'mt 2/6/2012 18:02:34.042'!
label

	^ self protocol! !

!UiSmalltalkProtocolNode methodsFor: 'item model - hierarchy' stamp: 'mt 4/27/2012 11:47:12.315'!
messages

	^ self organization listAtCategoryNamed: self protocol! !

!UiSmalltalkProtocolNode methodsFor: 'accessing' stamp: 'mt 1/23/2012 16:36:40.307'!
organization
	^ organization! !

!UiSmalltalkProtocolNode methodsFor: 'accessing' stamp: 'mt 1/23/2012 16:36:40.342'!
organization: anObject
	organization := anObject! !

!UiSmalltalkProtocolNode methodsFor: 'accessing' stamp: 'mt 1/23/2012 16:17:14.361'!
protocol
	^ protocol! !

!UiSmalltalkProtocolNode methodsFor: 'accessing' stamp: 'mt 1/23/2012 16:17:14.389'!
protocol: anObject
	protocol := anObject! !

Object subclass: #UiSystemProgressModel
	uses: TUiItemModel
	instanceVariableNames: 'rootNode currentNode mutex'
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'WidgetTools-SystemProgress'!

!UiSystemProgressModel commentStamp: 'mt 5/15/2012 10:51:02.91' prior: 0!
Broken. Needs update to current version of item-model framework.!

UiSystemProgressModel class
	uses: TUiItemModel classTrait
	instanceVariableNames: ''!

!UiSystemProgressModel class methodsFor: 'instance creation' stamp: 'mt 2/17/2011 21:08:21.353'!
close: aBlock

	self instance closeCurrentNode.
! !

!UiSystemProgressModel class methodsFor: 'instance creation' stamp: 'mt 2/9/2011 15:50:26.612'!
instance

	^ Instance ifNil: [Instance := super new]! !

!UiSystemProgressModel class methodsFor: 'instance creation' stamp: 'mt 2/9/2011 10:39:22.33'!
label: shortDescription min: minValue max: maxValue

	^ self instance
		label: shortDescription
		min: minValue
		max: maxValue! !

!UiSystemProgressModel class methodsFor: 'instance creation' stamp: 'mt 2/9/2011 15:51:12.037'!
reset

	Instance := nil.! !

!UiSystemProgressModel methodsFor: 'accessing - private' stamp: 'mt 2/20/2011 20:50:21.596'!
assureCurrentNode
	"See #currentNode."
	
	| id |	
	currentNode ifNil: [currentNode := Dictionary new].
	
	id := self currentId.
	
	^ currentNode at: id ifAbsent: [
		| node pos |
		node := self rootNode addChild:
			(UiSystemProgressNode new
				text: (ProcessBrowser new prettyNameForProcess: Processor activeProcess);
				id: id).
		
		currentNode at: id put: node.
		
		pos := self rootNode children indexOf: node.
		self rowsInsertedFor: nil from: pos to: pos.
		
		node].! !

!UiSystemProgressModel methodsFor: 'initialization' stamp: 'mt 2/25/2011 10:29:29.939'!
assureOpenView
	"Look for the morph that visualizes the model."
	
	(ActiveWorld submorphs
		detect: [:m | m isKindOf: UiSystemProgressMorph]
		ifNone: [UiSystemProgressMorph new openInWorld; center: ActiveWorld center]) ifNotNil: [:m |
			m comeToFront].! !

!UiSystemProgressModel methodsFor: 'nodes' stamp: 'mt 2/20/2011 19:02:31.653'!
closeCurrentNode
	"Indicate, that the current progress is done. The progress of a whole process cannot be closed as each process only has exactly one node in this tree model's root."
	
	| node index size |
	node := self currentNode.
	index := self currentIndex.
	
	node parent = self rootNode
		ifTrue: [^ self].
	
	node current: node maximum.
	
	self mutex critical: [
		currentNode at: self currentId put: self currentNode parent].
	
	"Update the last value for the node."
	size := self currentNode children size.
	self rowsChangedFor: self currentIndex from: size to: size.
	self nodeClosed: index.! !

!UiSystemProgressModel methodsFor: 'counts' stamp: 'mt 2/9/2011 09:56:25.392'!
columnCountFor: aParentModelIndex

	^ 2! !

!UiSystemProgressModel methodsFor: 'accessing' stamp: 'mt 2/17/2011 20:40:58.762'!
currentId

	^ Processor activeProcess name asNumber! !

!UiSystemProgressModel methodsFor: 'index generation' stamp: 'mt 2/17/2011 23:59:24.152'!
currentIndex
	"Calculates the current model index for this process."  
	
	| nodes index lastNode |
	nodes := OrderedCollection new.
	nodes add: self currentNode.
	
	"Walk up the parent hierarchy and store the path."
	[nodes last parent ~= self rootNode] whileTrue: [
		nodes add: nodes last parent].
	
	"Secure access to local-root for this process."
	self mutex critical: [
		index := self
			indexRow: (self rootNode children indexOf: nodes last)
			column: 1
			parent: nil].
	
	"Now walk down to current node again and create indices."
	lastNode := nodes last.
	nodes allButLast reverseDo: [:node |
		index := self
			indexRow: (lastNode children indexOf: node)
			column: 1
			parent: index.
		lastNode := node].
	
	^ index! !

!UiSystemProgressModel methodsFor: 'accessing' stamp: 'mt 2/17/2011 20:37:23.872'!
currentNode
	"Return the current progress node of the current process. Each process has its own 'process-local root' as a direct child of the actual root node of this system progress (tree) model. When a process tries to display progress the first time, a new node will be added for that process."

	^ self mutex critical: [self assureCurrentNode]! !

!UiSystemProgressModel methodsFor: 'index generation' stamp: 'mt 2/17/2011 19:54:04.249'!
indexRow: aRowNumber column: aColumnNumber parent: aParentModelIndex

	| node |
	(aRowNumber = 0 or: [aColumnNumber = 0])
		ifTrue: [^ (UiSimpleModelIndex row: aRowNumber column: aColumnNumber)
			model: self;
			parent: aParentModelIndex].
	
	aParentModelIndex
		ifNil: [node := self rootNode childAt: aRowNumber]
		ifNotNil: [:i | node := (i valueOfProperty: #node) childAt: aRowNumber].

	^ (UiSimpleModelIndex row: aRowNumber column: aColumnNumber)
		model: self;
		parent: aParentModelIndex;
		setProperty: #node toValue: node! !

!UiSystemProgressModel methodsFor: 'initialization' stamp: 'mt 2/20/2011 18:13:16.938'!
initialize

	super initialize.
	
	"Create node for UI process."
	"self currentNode."! !

!UiSystemProgressModel methodsFor: 'nodes' stamp: 'mt 2/20/2011 20:32:19.134'!
label: shortDescription min: minValue max: maxValue

	| node |
	self assureOpenView.
	
	node := self openCurrentNode: (UiSystemProgressNode new
		text: shortDescription;
		minimum: minValue;
		maximum: maxValue).
	
	^ [:currentValueOrLabel | | index |	
			currentValueOrLabel isNumber
				ifTrue: [node current: currentValueOrLabel]
				ifFalse: [node text: currentValueOrLabel].
			index := self currentIndex.
			self rowsChangedFor: index parent from: index row to: index row]! !

!UiSystemProgressModel methodsFor: 'nodes' stamp: 'mt 2/20/2011 20:31:55.227'!
labelAt: progressBlock put: aStringOrText
	"See #label:min:max: for definition of progressBlock."
	
	self assureOpenView.
	
	progressBlock value: aStringOrText.
	
	! !

!UiSystemProgressModel methodsFor: 'accessing' stamp: 'mt 2/17/2011 20:36:24.82'!
mutex

	^ mutex ifNil: [mutex := Mutex new]! !

!UiSystemProgressModel methodsFor: 'signals' stamp: 'mt 2/20/2011 19:01:34.313'!
nodeClosed: aModelIndex

	self emit.! !

!UiSystemProgressModel methodsFor: 'nodes' stamp: 'mt 2/17/2011 21:44:13.124'!
openCurrentNode: aNode
	"A new progress starts in context of the current node. That context is either the current process itself or another progress that is currently running."

	| node size index |
	node := self currentNode.
	index := self currentIndex.
	size := node children size.
	
	node addChild: aNode.

	self mutex critical: [
		currentNode at: self currentId put: aNode].
	
	self rowsInsertedFor: index from: size+1 to: size+1.
	
	^ aNode! !

!UiSystemProgressModel methodsFor: 'initialization' stamp: 'mt 2/20/2011 19:44:13.289'!
reset

	self mutex critical: [
		currentNode := nil].
	
	super reset.! !

!UiSystemProgressModel methodsFor: 'accessing' stamp: 'mt 2/17/2011 19:37:57.87'!
rootNode

	^ rootNode ifNil: [rootNode := UiSystemProgressNode new text: '(root)']! !

!UiSystemProgressModel methodsFor: 'counts' stamp: 'mt 2/9/2011 16:01:22.088'!
rowCountFor: aParentModelIndex

	^ aParentModelIndex
		ifNil: [self rootNode children size]
		ifNotNil: [:i | (i valueOfProperty: #node) children size]
	
	! !

!UiSystemProgressModel methodsFor: 'model data' stamp: 'mt 2/20/2011 21:24:06.782'!
textFor: aModelIndex

	| node value text |
	"No header text."
	(aModelIndex row = 0 or: [aModelIndex column = 0]) ifTrue: [^ nil].
	
	node := aModelIndex valueOfProperty: #node.
	value := node percentage.
	
	aModelIndex column = 1 ifTrue: [
		text := node text copy ifEmpty: ['<font color="#aaaaaa">Unknown activity happening...</font>' asHtmlText	]].
	aModelIndex column = 2 ifTrue: [
		(node id notNil or: [value = -1])
			ifTrue: [text := ' ' asText]
			ifFalse: [text := ('{1} %' format: {(value * 100) asInteger}) asText]].
	
	
	
	node finished ifTrue: [
		text addAttribute: (TextColor color: (Color r: 0 g: 0.5 b: 0))]. 

	^ text! !

Object subclass: #UiSystemProgressNode
	instanceVariableNames: 'parent children text minimum maximum id current'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WidgetTools-SystemProgress'!

!UiSystemProgressNode methodsFor: 'accessing' stamp: 'mt 2/17/2011 20:06:20.129'!
addChild: aNode

	(self children includes: aNode)
		ifTrue: [^ aNode].
		
	self children add: aNode.
	aNode parent: self.
	
	self childAdded: aNode.
	
	^ aNode! !

!UiSystemProgressNode methodsFor: 'signals' stamp: 'mt 2/9/2011 10:20:00.261'!
childAdded: aNode

	self emit.! !

!UiSystemProgressNode methodsFor: 'accessing' stamp: 'mt 2/9/2011 10:33:48.12'!
childAt: index

	^ self children at: index! !

!UiSystemProgressNode methodsFor: 'accessing' stamp: 'mt 2/9/2011 10:17:56.917'!
children

	^ children ifNil: [children := OrderedCollection new]! !

!UiSystemProgressNode methodsFor: 'accessing' stamp: 'mt 2/17/2011 21:12:17.744'!
current

	^ current ifNil: [current := self minimum]! !

!UiSystemProgressNode methodsFor: 'accessing' stamp: 'mt 2/17/2011 21:11:42.55'!
current: aNumber

	(aNumber between: self minimum and: self maximum)
		ifFalse: [^ self]  .

	current := aNumber.! !

!UiSystemProgressNode methodsFor: 'queries' stamp: 'mt 2/17/2011 20:17:28.717'!
detectChild: blockOrId
	"Search for the child that has the given id or matches the detect-block."

	^ blockOrId isBlock
		ifTrue: [self children detect: blockOrId ifNone: []]
		ifFalse: [self children detect: [:child | child id = id] ifNone: []]! !

!UiSystemProgressNode methodsFor: 'testing' stamp: 'mt 2/20/2011 20:45:34.445'!
finished

	^ self current = self maximum and: [self percentage > 0]! !

!UiSystemProgressNode methodsFor: 'accessing' stamp: 'mt 2/17/2011 20:13:38.469'!
id

	^ id! !

!UiSystemProgressNode methodsFor: 'accessing' stamp: 'mt 2/17/2011 20:13:49.859'!
id: aNumber

	id := aNumber.! !

!UiSystemProgressNode methodsFor: 'accessing' stamp: 'mt 2/9/2011 15:55:34.083'!
maximum

	^ maximum! !

!UiSystemProgressNode methodsFor: 'accessing' stamp: 'mt 2/9/2011 15:55:24.014'!
maximum: aNumber

	maximum := aNumber.! !

!UiSystemProgressNode methodsFor: 'accessing' stamp: 'mt 2/9/2011 15:55:03.743'!
minimum

	^ minimum! !

!UiSystemProgressNode methodsFor: 'accessing' stamp: 'mt 2/9/2011 15:55:10.482'!
minimum: aNumber

	minimum := aNumber.! !

!UiSystemProgressNode methodsFor: 'accessing' stamp: 'mt 2/9/2011 10:17:44.455'!
parent

	^ parent! !

!UiSystemProgressNode methodsFor: 'accessing' stamp: 'mt 2/9/2011 10:21:04.003'!
parent: aNode

	| oldParent |
	parent = aNode
		ifTrue: [^ self].
	
	oldParent := parent.
	parent := aNode.
	
	self parentChanged: parent from: oldParent.! !

!UiSystemProgressNode methodsFor: 'signals' stamp: 'mt 2/9/2011 10:20:18.851'!
parentChanged: newParent from: oldParent

	self emit.! !

!UiSystemProgressNode methodsFor: 'accessing' stamp: 'mt 2/20/2011 20:13:27.14'!
percentage

	(self maximum isNil or: [self minimum isNil] or: [self current isNil])
		ifTrue: [^ -1].
	
	self range = 0 ifTrue: [^ -1].
		
	^ self current - self minimum / self range! !

!UiSystemProgressNode methodsFor: 'accessing' stamp: 'mt 2/17/2011 21:12:47.989'!
range

	^ self maximum - self minimum! !

!UiSystemProgressNode methodsFor: 'accessing' stamp: 'mt 2/9/2011 15:54:58.606'!
text

	^ text! !

!UiSystemProgressNode methodsFor: 'accessing' stamp: 'mt 2/20/2011 21:25:16.556'!
text: stringOrText

	| tmp |
	tmp := stringOrText isString
		ifTrue: [stringOrText withBlanksTrimmed]
		ifFalse: [stringOrText].

	(tmp isString or: [tmp isText])
		ifTrue: [text := tmp asHtmlText]
		ifFalse: [text := tmp asString].! !

TestCase subclass: #UiSystemProgressTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WidgetTools-SystemProgress'!

!UiSystemProgressTests methodsFor: 'running' stamp: 'mt 2/17/2011 20:43:19.345'!
setUp

	super setUp.! !

!UiSystemProgressTests methodsFor: 'running' stamp: 'mt 2/17/2011 20:43:22.888'!
tearDown

	super tearDown.! !

!UiSystemProgressTests methodsFor: 'tests' stamp: 'mt 8/21/2012 11:17:01.068'!
test01rootNodeInitialization

	"| sut |
	sut := UiSystemProgressModel new.
	self assert: 1 equals: sut rootNode children size."! !

!UiSystemProgressTests methodsFor: 'tests' stamp: 'mt 8/21/2012 11:16:58.056'!
test02morphInitialization

	"| sut |
	sut := UiSystemProgressMorph new.
	self assert: 1 equals: sut ui view model rootNode children size."! !
